!!!     Author: Thanh Lam Nguyen (thanhlamnguyen08@gmail.com)
!!!     Department of Chemistry and Biochemistry, The UT at Austin
!!!     Sep 11, 2013

!!!     Name : CONVR, to convolute Vib. & Rot. sum/den 
!!!     Input : 1) a vector T(E): number of states
!!!             2) DELE : energy bin (or size of energy bin)
!!!             3) NMAX : maximum number of bins
!!!             4) Ev : a vector of energy levels (eigenvalues) 
!!!             5) N : a number of elements in the vector Ev. 
!!!             6) AT(E) is a temperary vector which always goes with
!T(E) 
!!!     Output : 1) Updated T(E) : a NEW vector of number of states 


        SUBROUTINE CONVR(T,AT,DELE,NMAX,Ev,N)

        IMPLICIT NONE

        INTEGER NMAX
        INTEGER I, J, LL, N
        DOUBLE PRECISION T(NMAX), AT(NMAX)
        DOUBLE PRECISION DELE, Ev(N)

        DO I=1, N
                LL=NINT(Ev(I)/DELE)
                DO J=1, NMAX-LL
                        AT(J+LL) = AT(J+LL) + T(J)
                ENDDO
        ENDDO
        DO I=1, NMAX
                T(I)=AT(I)
                AT(I)=0.0d0
        ENDDO

        RETURN
        END

