	SUBROUTINE driver_CRRKM( SS, DS, JMAX, DELE, N, FREQ ) 

	IMPLICIT NONE

integer, parameter :: qp = selected_real_kind(15, 307)

!! JMAX = Maxinum naumber of bins in master-equation
!! DELE = Energy bin
!! N = Number of Vibrational Degrees of Freedom (DOF) 
!! FREQ = Vector of harmonic vibration frequencies with N elements
!! SS (OUTPUT) = Vector of Sum of vibrational states 
!! DS (OUTPUT) = Vector of Density of vibrational states

	Integer I, N
	Integer JMAX
        real(kind=qp) :: DELE
	real(kind=qp) :: T(JMAX), AT(JMAX)
	real(kind=qp) :: SS(JMAX), DS(JMAX)
	real(kind=qp) :: FREQ(N)

	CALL TAT(T,AT,JMAX)

	DO I=1, N
		CALL HO(T,AT,DELE,JMAX,FREQ(I))
	ENDDO

	DS(1) = T(1)/DELE
	SS(1) = T(1)
	DO I=2, JMAX
		DS(I) = T(I)/DELE
		SS(I) = SS(I-1) + T(I)
	ENDDO

	RETURN
	END SUBROUTINE driver_CRRKM

