	SUBROUTINE driver_QRRKM_Eckart( SS, DS, V1, V2, JMAX, DELE, N, FREQ, IFREQ ) 

	IMPLICIT NONE

integer, parameter :: qp = selected_real_kind(15, 307)

!! JMAX = Maxinum number of bins in master-equation
!! DELE = Energy bin
!! N = Number of Vibrational Degrees of Freedom (DOF) 
!! FREQ = Vector of harmonic vibration frequencies with N elements
!! SS (OUTPUT) = Vector of Sum of vibrational states 
!! DS (OUTPUT) = Vector of Density of vibrational states
!! V1 : Forward barrier (cm-1)
!! V2 : Reverse barrier (cm-1)
!! IFREQ : Magnitude of Imaginary Frequency

	Integer I, J,  N
	Integer JMAX
        real(kind=qp) :: DELE, IFREQ, ENG
	real(kind=qp) :: V1, V2, V1b, V2b 
	real(kind=qp) :: T(JMAX), AT(JMAX)
	real(kind=qp) :: SS(JMAX), DS(JMAX)
	real(kind=qp) :: FREQ(N)
	real(kind=qp) :: PE 

	IF(V1.GT.V2) THEN
		V1b = V2
		V2b = V1
	ELSE
		V1b = V1
		V2b = V2
	ENDIF

	DO I=1, JMAX
		ENG = (I-1)*DELE
		AT(I) = 0.0
		T(I) = PE(ENG,V1b,V2b,IFREQ)
	ENDDO

	DO I=1, N
                CALL HO(T,AT,DELE,JMAX,FREQ(I))
	ENDDO

	DS(1) = T(1)/DELE
	SS(1) = T(1)
	DO I=2, JMAX
		DS(I) = (T(I)-T(I-1))/DELE
		SS(I) = T(I)
	ENDDO

	RETURN
	END SUBROUTINE driver_QRRKM_Eckart



