	SUBROUTINE driver_aVRRKM( GE, MX, MY, NMAX, DELE, JJ, &
                BL, UL, Step, Eto, E0, GW, CFR, SFR, MODEL, MLIN )

	IMPLICIT NONE

integer, parameter :: qp = selected_real_kind(15, 307)

!! MX = Number of Grid Points
!! MY = Number of harmonic frequencies (3N-7), projecting out the Reaction Coordinate
!! BL = Lower Limit of bond length 
!! UL = Upper Limit of bond length 
!! Eto = Energy of Reactant (kcal/mol)
!! E0 = Energy of the lowest-lying intermediate (kcal/mol)
!! Step = step size used to locate a variational bottleneck.
!! NMAX = maxinum number of bins in master-equation
!! DELE = energy bin
!! GE = vector of sum of states for the bottleneck
!! GW = matrix with a dimension of (MX x (MY+4)) that contains harmonic frequencies, rot. constants, and barrier heights for Grid Points

        Integer NMAX, JJ
        Integer MX, MY

        real(kind=qp) ::  GW(MX,MY+4), GE(NMAX)

	real(kind=qp) :: BL, UL, Step, Eto, E0
        real(kind=qp) :: DELE, SFR

        CHARACTER*3 CFR
        CHARACTER*8 MODEL, MLIN 

        
        IF(MLIN.EQ."LINEAR") THEN
        CALL driverlin_VRRKM( GE, MX, MY, NMAX, DELE, JJ, &
                BL, UL, Step, Eto, E0, GW, CFR, SFR, MODEL, MLIN )
        ELSE 
        CALL driver_VRRKM( GE, MX, MY, NMAX, DELE, JJ, &
                BL, UL, Step, Eto, E0, GW, CFR, SFR, MODEL, MLIN )
        ENDIF

	RETURN
	END SUBROUTINE driver_aVRRKM
	
