!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCC
!CCC Name       : SUBROUTINE EVT 
!CCC Purpose    : To convolute vib. and rot. quantum states 
!CCC 
!CCC Authors    : Thanh Lam Nguyen (thanhlamnguyen08@gmail.com)
!CCC              John F. Stanton  (jfstanton@gmail.com)
!CCC
!CCC Date       : Apr. 18, 2014
!CCC Where      : The University of Texas at Austin
!CCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


        SUBROUTINE EVT(T,AT,DELE,Maxi,Ev,N)

        IMPLICIT NONE

!!!  T          : number of states
!!!  AT         : temperary vector
!!!  DELE       : energy bin
!!!  Maxi       : maximum index in master-equation
!!!  Ev         : vector of energy levels
!!!  N          : a number of elements in Ev vector.

        INTEGER Maxi
        INTEGER I, J, LL, N
        REAL*8 T(Maxi), AT(Maxi)
        REAL*8 DELE, Ev(N)

        DO I=1, N
                LL=NINT(Ev(I)/DELE)
                DO J=1, Maxi-LL
                        AT(J+LL) = AT(J+LL) + T(J)
                ENDDO
        ENDDO
        DO I=1, Maxi
                T(I)=AT(I)
                AT(I)=0.0D0
        ENDDO

        RETURN
        END
